﻿#include "info-reader/feature-info-tokens-table.h"

/*!
 * @brief 地形属性トークンの定義 / Feature info flags
 */
const std::unordered_map<std::string_view, FF> f_info_flags = {
    { "LOS", FF::LOS },
    { "PROJECT", FF::PROJECT },
    { "MOVE", FF::MOVE },
    { "PLACE", FF::PLACE },
    { "DROP", FF::DROP },
    { "SECRET", FF::SECRET },
    { "NOTICE", FF::NOTICE },
    { "REMEMBER", FF::REMEMBER },
    { "OPEN", FF::OPEN },
    { "CLOSE", FF::CLOSE },
    { "BASH", FF::BASH },
    { "SPIKE", FF::SPIKE },
    { "DISARM", FF::DISARM },
    { "STORE", FF::STORE },
    { "TUNNEL", FF::TUNNEL },
    { "MAY_HAVE_GOLD", FF::MAY_HAVE_GOLD },
    { "HAS_GOLD", FF::HAS_GOLD },
    { "HAS_ITEM", FF::HAS_ITEM },
    { "DOOR", FF::DOOR },
    { "TRAP", FF::TRAP },
    { "STAIRS", FF::STAIRS },
    { "RUNE_PROTECTION", FF::RUNE_PROTECTION },
    { "LESS", FF::LESS },
    { "MORE", FF::MORE },
    { "AVOID_RUN", FF::AVOID_RUN },
    { "FLOOR", FF::FLOOR },
    { "WALL", FF::WALL },
    { "PERMANENT", FF::PERMANENT },
    // { "XXX00", FF::XXX00 },
    // { "XXX01", FF::XXX01 },
    // { "XXX02", FF::XXX02 },
    { "HIT_TRAP", FF::HIT_TRAP },

    // { "BRIDGE", FF::BRIDGE },
    // { "RIVER", FF::RIVER },
    // { "LAKE", FF::LAKE },
    // { "BRIDGED", FF::BRIDGED },
    // { "COVERED", FF::COVERED },
    { "GLOW", FF::GLOW },
    { "ENSECRET", FF::ENSECRET },
    { "WATER", FF::WATER },
    { "LAVA", FF::LAVA },
    { "SHALLOW", FF::SHALLOW },
    { "DEEP", FF::DEEP },
    { "POISON_PUDDLE", FF::POISON_PUDDLE },
    { "HURT_ROCK", FF::HURT_ROCK },
    // { "HURT_FIRE", FF::HURT_FIRE },
    // { "HURT_COLD", FF::HURT_COLD },
    // { "HURT_ACID", FF::HURT_ACID },
    { "COLD_PUDDLE", FF::COLD_PUDDLE },
    { "ACID_PUDDLE", FF::ACID_PUDDLE },
    // { "OIL", FF::OIL },
    { "ELEC_PUDDLE", FF::ELEC_PUDDLE },
    // { "CAN_CLIMB", FF::CAN_CLIMB },
    { "CAN_FLY", FF::CAN_FLY },
    { "CAN_SWIM", FF::CAN_SWIM },
    { "CAN_PASS", FF::CAN_PASS },
    // { "CAN_OOZE", FF::CAN_OOZE },
    { "CAN_DIG", FF::CAN_DIG },
    // { "HIDE_ITEM", FF::HIDE_ITEM },
    // { "HIDE_SNEAK", FF::HIDE_SNEAK },
    // { "HIDE_SWIM", FF::HIDE_SWIM },
    // { "HIDE_DIG", FF::HIDE_DIG },
    // { "KILL_HUGE", FF::KILL_HUGE },
    // { "KILL_MOVE", FF::KILL_MOVE },

    // { "PICK_TRAP", FF::PICK_TRAP },
    // { "PICK_DOOR", FF::PICK_DOOR },
    // { "ALLOC", FF::ALLOC },
    // { "CHEST", FF::CHEST },
    // { "DROP_1D2", FF::DROP_1D2 },
    // { "DROP_2D2", FF::DROP_2D2 },
    // { "DROP_GOOD", FF::DROP_GOOD },
    // { "DROP_GREAT", FF::DROP_GREAT },
    // { "HURT_POIS", FF::HURT_POIS },
    // { "HURT_ELEC", FF::HURT_ELEC },
    // { "HURT_WATER", FF::HURT_WATER },
    // { "HURT_BWATER", FF::HURT_BWATER },
    // { "USE_FEAT", FF::USE_FEAT },
    // { "GET_FEAT", FF::GET_FEAT },
    // { "GROUND", FF::GROUND },
    // { "OUTSIDE", FF::OUTSIDE },
    // { "EASY_HIDE", FF::EASY_HIDE },
    // { "EASY_CLIMB", FF::EASY_CLIMB },
    // { "MUST_CLIMB", FF::MUST_CLIMB },
    { "TREE", FF::TREE },
    // { "NEED_TREE", FF::NEED_TREE },
    // { "BLOOD", FF::BLOOD },
    // { "DUST", FF::DUST },
    // { "SLIME", FF::SLIME },
    { "PLANT", FF::PLANT },
    // { "XXX2", FF::XXX2 },
    // { "INSTANT", FF::INSTANT },
    // { "EXPLODE", FF::EXPLODE },
    // { "TIMED", FF::TIMED },
    // { "ERUPT", FF::ERUPT },
    // { "STRIKE", FF::STRIKE },
    // { "SPREAD", FF::SPREAD },

    { "SPECIAL", FF::SPECIAL },
    { "HURT_DISI", FF::HURT_DISI },
    { "QUEST_ENTER", FF::QUEST_ENTER },
    { "QUEST_EXIT", FF::QUEST_EXIT },
    { "QUEST", FF::QUEST },
    { "SHAFT", FF::SHAFT },
    { "MOUNTAIN", FF::MOUNTAIN },
    { "BLDG", FF::BLDG },
    { "RUNE_EXPLOSION", FF::RUNE_EXPLOSION },
    { "PATTERN", FF::PATTERN },
    { "TOWN", FF::TOWN },
    { "ENTRANCE", FF::ENTRANCE },
    { "MIRROR", FF::MIRROR },
    { "UNPERM", FF::UNPERM },
    { "TELEPORTABLE", FF::TELEPORTABLE },
    { "CONVERT", FF::CONVERT },
    { "GLASS", FF::GLASS },
};
